# class Box(T)

- Box(T)
- Reference
- Object

##
Overview

A Box allows turning any object to a `Void*` and back.

A Box's purpose is passing data to C as a `Void*` and then converting that back to the original data type.

For an example usage, see `Proc`'s explanation about sending Procs to C.

##
Defined in:

##
Constructors

- .new(object : T)

  Creates a `Box` with the given object.

##
Class Method Summary

- .box(r : Reference?) : Pointer(Void)

  Creates a Box for a reference type (or `nil`) and returns the same pointer (or `NULL`)

- .box(object) : Pointer(Void)

  Creates a Box for an object and returns it as a `Void*`.

- .unbox(pointer : Pointer(Void)) : T

  Unboxes a `Void*` into an object of type `T`.

##
Instance Method Summary

- #object : T

  Returns the original object

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(object : T) #

Creates a `Box` with the given object.

This method isn't usually used directly. Instead, `Box.box` is used.

##
Class Method Detail

def self.box(r : Reference?) : Pointer(Void) #

Creates a Box for a reference type (or `nil`) and returns the same pointer (or `NULL`)

def self.box(object) : Pointer(Void) #

Creates a Box for an object and returns it as a `Void*`.

def self.unbox(pointer : Pointer(Void)) : T #

Unboxes a `Void*` into an object of type `T`. Note that for this you must specify T: `Box(T).unbox(data)`.

##
Instance Method Detail

def object : T #

Returns the original object